"use client";
import React, { useEffect, useRef, useState } from "react";
import { io } from "socket.io-client";

const port = 5000;
const SocketComunicatio = () => {
  const [socket_conn, setSocket] = useState<any>();
  const [message, setMessage] = useState<any>("");
  const socketCreated = useRef(false);

  function connectSocket() {
    const socket = io(`:${port + 1}`, {
      path: "/api/socket",
      addTrailingSlash: false,
    });

    socket.on("connect", () => {
      console.log("Connected");
      socket.emit("JOIN_BRANCH", { branch: 1 });
    });

    socket.on("message", async (msg) => {
      console.log(msg.message);
      setMessage(msg.message);
    });

    socket.on("connect_error", async (err) => {
      console.log(`connect_error due to ${err.message}`);
      await fetch("/api/socket");
    });

    return socket;
  }

  useEffect(() => {
    async function init() {
      var _socket = await connectSocket();
      setSocket(_socket);
    }
    if (!socketCreated.current) {
      init();
      socketCreated.current = true;
    }
  }, [socket_conn]);

  return (
    <div>
      SocketComunication
      <br />
      <>{message}</>
      <>
        <br />

        <button
          onClick={async () => {
            socket_conn.emit("message", "hello ");
          }}
        >
          Brodcast simple Message
        </button>
        <br />

        <button
          onClick={async () => {
            socket_conn.emit("DINE_ORDERS", {
              branch: 1,
              orderid: 20,
              tableid: 1,
            });
          }}
        >
          Brodcast New dine Order
        </button>
        <br />

        <button
          onClick={async () => {
            socket_conn.emit("TABLE_CHANGE", {
              branch: 1,
              tableid: 1,
              status: "OPEN",
            });
          }}
        >
          Brodcast Table Chnage
        </button>
        <br />
        <br />
        <button
          onClick={async () => {
            socket_conn.emit("ORDER_PLACED", {
              branch: 1,
              tableid: 1,
              status: "OPEN",
            });
          }}
        >
          Brodcast New order
        </button>
        <br />
        <button
          onClick={async () => {
            socket_conn.emit("DELIVERY_ORDER", {
              branch: 1,
              order_id: 1,
              customer_name: "Nextjs server",
            });
          }}
        >
          Brodcast to Delivery Boy
        </button>
      </>
    </div>
  );
};

export default SocketComunicatio;
